<?php

// Sécurité
if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

/**
 * Pre-traiter les balises math : si elles contiennent des notes il faut propager dans les notes
 * @param string $texte
 * @return string
 */
function mathjax_pre_propre($texte) {

	// test rapide pour eviter de faire plein de choses pour rien
	if (($p = strpos($texte, '<math>')) !== false
	  and (strpos($texte, '[[', $p) !== false)) {

		include_spip('inc/math');
		if ($collection = mathjax_collecter_balises_math($texte)) {
			$collection = array_reverse($collection);

			foreach ($collection as $c) {
				if (strpos($c['raw'], '[[') !== false) {
					$texte_math = math_propager_dans_les_notes($c['raw']);
					$texte = substr_replace($texte, $texte_math, $c['pos'], $c['length']);
				}
			}

		}

	}
	return $texte;
}

function mathjax_insert_head($flux){
	$flux .= mathjax_flux();
	return $flux;
}

function mathjax_header_prive($flux){
	$flux .= mathjax_flux();
	return $flux;
}

function mathjax_flux(){
	include_spip("inc/config");
	$param = "MathJax.Hub.Config({";
	$param .= "tex2jax: {";
	// possibilité d'inserer une config specifique
	$param .= "}";
	$param .= "});";
	$flux = '<script type="text/x-mathjax-config">'.$param.'</script>';
	if (lire_config('mathjax/mode_dappel', 'cdn') == 'cdn') {
		$flux .= '<script type="text/javascript" async src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS_HTML"></script>';
	} else if (lire_config('mathjax/mode_dappel', 'cdn') == 'download') {
		$js = find_in_path('lib/mathjax/MathJax.js').'?config=TeX-AMS_HTML';
		$flux .= '<script type="text/javascript" src="'.$js.'"></script>';
	}

	// DEBUG : surligner les formules
	// $flux .= "<style>.spip-math {background: yellow}</style>";

	return $flux;
}
